(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: facile.ml,v 1.8 2001/01/15 13:16:32 barnier Exp $ *)

module Ac6 = Fcl_ac6
module Cstr = Fcl_cstr
module Genesis = Fcl_genesis
module Reify = Fcl_reify
module Alldiff = Fcl_alldiff
module Debug = Fcl_debug
module Goals = Fcl_goals
module Sorting = Fcl_sorting
module Arith = Fcl_arith
module Domain = Fcl_domain
module Interval = Fcl_interval
module Stak = Fcl_stak
module Binary = Fcl_binary
module FdArray = Fcl_fdArray
module Misc = Fcl_misc
module Var = Fcl_var
module Gcc = Fcl_gcc
module Opti = Fcl_opti

module Easy = struct
  let i2e = Arith.i2e
  let fd2e = Arith.fd2e
  let ( +~ ) = Arith.( +~ )
  let ( *~ ) = Arith.( *~ )
  let ( -~ ) = Arith.( -~ )
  let ( /~ ) = Arith.( /~ )
  let ( **~ ) = Arith.( **~ )
  let ( %~ ) = Arith.( %~ )
  let ( <=~ ) = Arith.( <=~ )
  let ( <~ ) = Arith.( <~ )
  let ( >~ )  = Arith.( >~ ) 
  let ( =~ )  = Arith.( =~ ) 
  let ( <>~ ) = Arith.( <>~ )
  let ( >=~ ) = Arith.( >=~ )
  let ( <=~~ ) = Arith.( <=~~ )
  let ( <~~ )  = Arith.( <~~ ) 
  let ( >~~ )  = Arith.( >~~ ) 
  let ( =~~ )  = Arith.( =~~ ) 
  let ( <>~~ ) = Arith.( <>~~ )
  let ( >=~~ ) = Arith.( >=~~ )
  let (&&~~) = Reify.(&&~~)
  let (||~~) = Reify.(||~~)
  let (=>~~) = Reify.(=>~~)
  let (<=>~~) = Reify.(<=>~~)

  let ( &&~ ) = Goals.( &&~ )
  let ( ||~ ) = Goals.( ||~ )

  module Fd = Var.Fd
  type concrete_fd = Var.concrete_fd = Unk of Var.Attr.t | Val of int
end
