(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_binary.ml,v 1.8 2001/01/12 11:58:37 brisset Exp $ *)

open Fcl_var

class binary var1 var2 nogoods =
  let min = Fd.min var1
  and nogoods1 =
    Array.init (Fd.max var1 - Fd.min var1+1)
      ~f:(fun i ->
	(List.fold_right
	   ~f:(fun (x1, x2) acc -> if x1 = i+Fd.min var1 then x2::acc else acc) nogoods ~init:[])) in

 object
  inherit Fcl_cstr.t Fcl_cstr.normal
  method name = "binary"
  method delay x =
    delay [Attr.on_refine] var1 x;
    delay [Attr.on_refine] var2 x
  method update =
    if not (Fcl_stak.get solved) then begin
      match Fd.value var1 with
	Unk attr ->
	  Attr.iter attr
	    (fun x ->
	      try
	    	Fd.iter var2
		  (fun y -> if not (List.mem y nogoods1.(x-min)) then raise Exit);
	    	match Fd.value var1 with
		  Unk var1_ -> Fd.refine var1  (Fcl_domain.remove x (Attr.dom var1_))
	    	| Val xx -> assert(x = xx); Fcl_stak.fail "binary"
	      with
	    	Exit -> ())
      |	Val x ->
	  Fd.iter var2
	    (fun y ->
	      if List.mem y nogoods1.(x-min)
	      then match Fd.value var2 with
		Val yy -> assert(y = yy); Fcl_stak.fail "binary2"
	      |	Unk var2_ -> Fd.refine var2 (Fcl_domain.remove y (Attr.dom var2_)));
	  Fcl_stak.set solved true
    end
end

open Fcl_arith


let cstr var1 var2 ng =
  let c1 = Fcl_reify.boolean ~delay_on_negation:false (new binary var1 var2 ng)
  and c2 = Fcl_reify.boolean ~delay_on_negation:false (new binary var2 var1 (List.map ~f:(fun (x,y)-> (y,x)) ng)) in

  fd2e c1 +~ fd2e c2 =~ i2e 2
