(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_gcc.mli,v 1.10 2001/02/06 10:03:15 brisset Exp $ *)

(* Module [Gcc]: global cardinality constraint (aka distribute) *)

type level = Basic | Medium | High
val cstr : ?level:level -> Fcl_var.Fd.t array -> (Fcl_var.Fd.t * int) array -> Fcl_cstr.t
(* [cstr (?level:High) vars distribution] returns a constraint ensuring
   that for each pair [(c,v)] of cardinal variable [c] and integer
   value [v] in the list [distribution], [c] variables in the array
   [vars] will be instantiated to [v],
   i.e. [card\{vi = v | vi in vars\} = c]. All values [v] in [distribution]
   must be different otherwise the exception [Invalid_argument] is raised. Three
   levels of propagation are provided : [Basic] is the quickest, [High] performs
   the highest amount of propagation. [level] default value is [High]. Not
   reifiable. *)
