(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_misc.mli,v 1.5 2001/01/18 09:45:50 brisset Exp $ *)

(* Module [Misc]: straightforwardly eponymous *)

val remove_duplicates : 'a list -> 'a list
(* _Undocumented_
   Remove multiple occurences in a list. Obsolete for [Fcl_domain.make]:
   [remove_sorted_duplicates] used instead. *)
val last_and_length : 'a list -> 'a * int
(* _Undocumented_
   Return the last element as well as the size of a list. Used by
   [Fcl_domain.make]. *)
val gen_int : unit -> int
(* _Undocumented_
   Generate a unique integer. Used to generate identification keys. *)
val connexity : ('a -> 'a -> bool) -> 'a list -> 'a list list
(* _Undocumented_
   [connexity edges vertices] return the connex components of the
   graph [(vertices, edges)]. Obsolete. *)
val delete : 'a -> 'a list -> 'a list
  (* _Undocumented_
     [delete e l] removes the first occurrence (=) of [e] in [l]. Raise
     Not_found if [e] is not in [l]. Obsolete. *)

val int_overflow : float -> bool
  (*  _Undocumented_
     [int_overflow x] returns [true] iff [float max_int < x] or
     [float min_int > x], [false] otherwise. Used in Operators and
     [Fcl_arith.expn_int]. *)

module Operators : sig
  val (=+) : int ref -> int -> unit
(*  _Undocumented_
   [x =+ n] C-like increment operator. Equivalent to [x := !x+n]. *)
  val min : int -> int -> int
(* _Undocumented_
   Non-polymorphic [min] over integers. For optimization purpose. *)
  val max : int -> int -> int
(* _Undocumented_
   Non-polymorphic [max] over integers. For optimization purpose. *)

  val ( * ) : int -> int -> int
  val (+) : int -> int -> int
  val (-) : int -> int -> int
  (* _Undocumented_
     Standard integer arithmetic operators with overflow checking raising an
     assert failure. Disabled if compiled with the -noassert flag. Used
     in [Fcl_arith]. *)
end

val iter : ('a -> 'a) -> int -> 'a -> 'a
  (* _Undocumented_
     [iter f n z] computes [(f (f ... n] times [... (f z)))]. Used in
     Fcl_arith.( **~). *)
val godel : (int -> 'a -> 'a) -> int -> 'a -> 'a
  (* _Undocumented_
     [godel f n z] computes [(f (n-1) (f (n-2) ... n] times [... (f 0 z)))].
     Used in [Fcl_gcc]. *)

module Array : sig
  val iter2 : ('a -> 'b -> unit) -> 'a array -> 'b array -> unit
(* _Undocumented_
   Iteration on two arrays. Obsolete. *)
end

val protect : string -> (unit -> 'a) -> 'a
  (* _Undocumented_
     [protect name f] calls [f] and controls that it is
     not called inside itself. Raises an exception using [name] if it is
     the case. Example: let my_fun my_arg = protect "my_fun" (fun () -> ...).
  *)
