(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_opti.mli,v 1.12 2001/01/09 13:11:42 barnier Exp $ *)

(* Module [Opti]: Branch and Bound optimization *)

val minimize : Fcl_goals.t -> Fcl_var.Fd.t -> ?control:(int -> unit) -> ?step:int -> (int -> 'a) -> 'a option
 (* [minimize goal cost ?control (?step:1) solution] runs a Branch and Bound
    algorithm on [goal] for bound [cost], with an improvment of a least [step]
    between each solution found. [solution] is called with the instantiation
    value of [cost] as argument each time a solution is found. The result is
    the value returned by [solution] on the last solution (if any).
    [?control] is passed to [Goals.solve] as its first (optional)
    argument. Default [control] does nothing (i.e. [fun _ -> ()]).
    Default [step] is 1. *)
